  MEMBER
  Include('zint.inc')

  !   : Self.Debug() !!!  -    MZ4x5.Report_Client
  
  MAP
    Include('cwutil.inc'),Once

    MODULE('zintapi')
      ZBarcode_Create(),Long,      Raw,C,Name('ZBarcode_Create') ! Create and initialize a symbol structure
      ZBarcode_Clear( Long symbol),Raw,C,Name('ZBarcode_Clear')  ! Free any output buffers that may have been created and initialize output fields
      ZBarcode_Reset( Long symbol),Raw,C,Name('ZBarcode_Reset')  ! Free any output buffers that may have been created and reset all fields to defaults      
      ZBarcode_Delete(Long symbol),Raw,C,Name('ZBarcode_Delete') ! Free a symbol structure, including any output buffers

      ZBarcode_Encode(                       Long symbol, const *String source, Long in_length),Long,Raw,C,Name('ZBarcode_Encode')
      ZBarcode_Encode_Segs(                  Long symbol, *Group[] segs, Long seg_count),       Long,Raw,C,Name('ZBarcode_Encode_Segs')  ! No Test: *Group[] segs
      ZBarcode_Encode_File(                  Long symbol, *CString filename),                   Long,Raw,C,Name('ZBarcode_Encode_File')

      ZBarcode_Print(                        Long symbol,                                Long rotate_angle),Long,Raw,C,Name('ZBarcode_Print')
      ZBarcode_Encode_and_Print(             Long symbol, *String input, Long in_length, Long rotate_angle),Long,Raw,C,Name('ZBarcode_Encode_and_Print')
      ZBarcode_Encode_Segs_and_Print(        Long symbol, *Group[] segs, Long seg_count, Long rotate_angle),Long,Raw,C,Name('ZBarcode_Encode_Segs_and_Print')
      ZBarcode_Encode_File_and_Print(        Long symbol, *CString filename,             Long rotate_angle),Long,Raw,C,Name('ZBarcode_Encode_File_and_Print')

      ZBarcode_Buffer(                       Long symbol,                                Long rotate_angle),Long,Raw,C,Name('ZBarcode_Buffer')
      ZBarcode_Encode_and_Buffer(            Long symbol, *String input, Long in_length, Long rotate_angle),Long,Raw,C,Name('ZBarcode_Encode_and_Buffer')
      ZBarcode_Encode_Segs_and_Buffer(       Long symbol, *Group[] segs, Long seg_count, Long rotate_angle),Long,Raw,C,Name('ZBarcode_Encode_Segs_and_Buffer')
      ZBarcode_Encode_File_and_Buffer(       Long symbol, *CString filename,             Long rotate_angle),Long,Raw,C,Name('ZBarcode_Encode_File_and_Buffer')

      ZBarcode_Buffer_Vector(                Long symbol, Long rotate_angle),                               Long,Raw,C,Name('ZBarcode_Buffer_Vector')
      ZBarcode_Encode_and_Buffer_Vector(     Long symbol, *String input, Long in_length, Long rotate_angle),Long,Raw,C,Name('ZBarcode_Encode_and_Buffer_Vector')
      ZBarcode_Encode_Segs_and_Buffer_Vector(Long symbol, *Group[] segs, Long seg_count, Long rotate_angle),Long,Raw,C,Name('ZBarcode_Encode_Segs_and_Buffer_Vector')
      ZBarcode_Encode_File_and_Buffer_Vector(Long symbol, *CString filename,             Long rotate_angle),Long,Raw,C,Name('ZBarcode_Encode_File_and_Buffer_Vector')

      ZBarcode_ValidID(                      Long symbol_id),               Long, Raw,C,Name('ZBarcode_ValidID')
      ZBarcode_BarcodeName(                  Long symbol_id,*CString name), Long, Raw,C,Name('ZBarcode_BarcodeName')
      ZBarcode_Cap(                          Long symbol_id,ULong cap_flag),ULong,Raw,C,Name('ZBarcode_Cap')
      ZBarcode_Version(),                                                   Long, Raw,C,Name('ZBarcode_Version')
      ZBarcode_NoPng(),                                                     Long, Raw,C,Name('ZBarcode_NoPng')

!    /* Return default X-dimension in mm for symbology `symbol_id`. Returns 0 on error (invalid `symbol_id`) */
!    ZINT_EXTERN float ZBarcode_Default_Xdim(int symbol_id);
!
!    /* Return the scale to use for `symbol_id` for non-zero X-dimension `x_dim_mm` at `dpmm` dots per mm for
!       `filetype`. If `dpmm` zero defaults to 12. If `filetype` NULL/empty, defaults to "GIF". Returns 0 on error */
!    ZINT_EXTERN float ZBarcode_Scale_From_XdimDp(int symbol_id, float x_dim_mm, float dpmm, const char *filetype);
!
!    /* Reverse of `ZBarcode_Scale_From_XdimDp()` above to estimate the X-dimension or dpmm given non-zero `scale` and
!       non-zero `x_dim_mm_or_dpmm`. Return value bound to dpmm max not X-dimension max. Returns 0 on error */
!    ZINT_EXTERN float ZBarcode_XdimDp_From_Scale(int symbol_id, float scale, float x_dim_mm_or_dpmm,
!                        const char *filetype);

     !ZBarcode_Render(Long symbol, SReal width, SReal height),Long,Raw,C,Name('ZBarcode_Render')
    end

    Module('zint.clw')
      ZINT:GetRAMPath(),String
      ZINT:GetGUID(),String
      ZINT:CheckEan13(String,*CString,*Byte),Byte
    end

    Module('Windows API')
      !   GUID
      ZINT:CoCreateGuid(*?),UNSIGNED,PASCAL,RAW,NAME('CoCreateGuid')
      ZINT:StringFromGUID2(*?,*?,LONG cchMax),UNSIGNED,PASCAL,RAW,NAME('StringFromGUID2')

      ZINT:DeleteFileAPI(*CSTRING lpFileName),BOOL,PROC,RAW,PASCAL,name('DeleteFileA')

      !    UTF-8
      ZINT:WideCharToMultiByte(UNSIGNED Codepage=0,USHORT dwFlags=0,ULong LpWideCharStr, Long cchWideChar, ULong lpMultuByteStr, |
                               Long cbMultiByte,Ulong LpDefalutChar,BYTE lpUsedDefalutChar),Raw,UNSIGNED,Pascal,NAME('WideCharToMultiByte')

      ZINT:MultiByteToWideChar(UNSIGNED Codepage=0,USHORT dwFlags=0,ULong LpMultuByteStr,Long cbMultiByte, ULong LpWideCharStr,|
                               Long cchWideChar),UNSIGNED,RAW,PASCAL,NAME('MultiByteToWideChar')

      ZINT:GETACP(),RAW,USHORT,PASCAL,NAME('GETACP')
      ZINT:memcpy(Long lpDest,Long lpSource,Long nCount),Long,Proc,Name('_memcpy')
    end
  end

  PRAGMA('link (zint.lib)')

ZintClass.Construct  Procedure
  Code

  Self.xQIList &= New(ZINT_xTypeQImage)  !    -
  If Not (Self.xQIList &= Null) then Free(Self.xQIList).

  Self.FileExt =  'gif'  !    
  !Self.FileExt =  'bmp'  !    
  !Self.FileExt =  'png'  !     -> : PNG format disabled compile time
  Self.IPar   :=: 0      !    

ZintClass.Destruct   Procedure
Loc:xCount    Long
Loc:xTMPPath  CString(File:MaxFilePath)
Loc:xTMPFile  CString(File:MaxFileName)
  Code

  If Self.FlagArmed = True then Self.Kill.

                                         !    -
  If Not (Self.ImageBuffer &= Null) then Dispose(Self.ImageBuffer).

  If Not (Self.xQIList &= Null)          !    XLSX 
     If Records(Self.xQIList) > 0

        Loc:xTMPPath = ZINT:GetRAMPath()

        Loop Loc:xCount = 1 to Records(Self.xQIList)
          Get(Self.xQIList,Loc:xCount)
          If (Len(Clip(Self.xQIList.iFile)) = 40) and Exists(Loc:xTMPPath & Self.xQIList.iFile)
             Loc:xTMPFile = Loc:xTMPPath & Self.xQIList.iFile
             ZINT:DeleteFileAPI(Loc:xTMPFile)
          end
        end

        Free(Self.xQIList)
     end

     Dispose(Self.xQIList)
  end

ZintClass.Init       Procedure(Byte bAltSetColor = False)
  Code

  Self.Kill()        !  (     ZINT)

  If Self.FlagArmed = False
     Self.Handle    = ZBarcode_Create()
     Self.FlagArmed = True
  end

  Self.ZClear()      !  
                     !     Self.Setting
  Self.ZConfigure(bAltSetColor)

  Return Self.FlagArmed

ZintClass.Kill       Procedure
  Code

  If Self.FlagArmed = True
     ZBarcode_Delete(Self.Handle)
     Self.FlagArmed = False
  end

! ---     Self.Setting
ZintClass.ZConfigure Procedure(Byte bAltSetColor)
bSetQuietZone  Byte(False)
  Code

  If Self.FlagArmed = True
     Self.SetupSymbol('symbology',         Self.Setting.sSymbol)        !  -

     If Not bAltSetColor
        Self.SetupSymbol('fgcolour',       Self.Setting.sColor)         !  
        Self.SetupSymbol('bgcolour',       Self.Setting.sCBack)         ! 
     else
        Self.SetupSymbol('fgcolour2',      Self.Setting.sColor)         !    
        Self.SetupSymbol('bgcolour2',      Self.Setting.sCBack)         !     :(
     end

    !Self.SetupSymbol('outfile',           'out.gif')                   ! 20.04.2025   GIF, ..    PNG
     
     Self.SetupSymbol('input_mode',        ZINT_DATA_MODE)

     Self.SetupSymbol('option_1',          Self.Setting.option_1)       !    2D
     Self.SetupSymbol('option_2',          Self.Setting.option_2)       !  2D
     Self.SetupSymbol('option_3',          Self.Setting.option_3)

     Self.SetupSymbol('height',            Self.Setting.sHeight)        !  -
     Self.SetupSymbol('whitespace_width',  Self.Setting.sWSpaceWidth)   !   
     Self.SetupSymbol('whitespace_height', Self.Setting.sWSpaceHeight)  !   

     Self.SetupSymbol('border_width',      Self.Setting.sBorderWidth)   !  

     !           -   
     If Self.Setting.sHideText  and Self.CapSymbol(Self.Setting.sSymbol,ZINT_CAP_HRT)
        Self.SetupSymbol('show_hrt',     False)
        Self.SetupSymbol('guard_descent',0)
     end

     !          -     - 
     If Self.Setting.sQuietZone and Not Self.CapSymbol(Self.Setting.sSymbol,ZINT_CAP_QUIET_ZONES) then bSetQuietZone = True.

     Self.SetupSymbol('output_options',    Choose(Self.Setting.sBoldText    = True, ZINT_BOLD_TEXT,             0) + |  !  
                                           Choose(Self.Setting.sSmallText   = True, ZINT_SMALL_TEXT,            0) + |  !     
                                           Choose(Self.Setting.sBorderWidth > 0,    ZINT_BARCODE_BOX,           0) + |  !     
                                           Choose(bSetQuietZone             = True, ZINT_BARCODE_QUIET_ZONES,   0) + |  !    (    )
                                           Choose(Self.Setting.sNoQuietZone = True, ZINT_BARCODE_NO_QUIET_ZONES,0) + |  !      (   )
                      0)

     Case Self.Setting.sSymbol
     Of ZINT_BARCODE_DATAMATRIX
        Self.SetupSymbol('option_3', ZINT_DM_SQUARE)  !    

     Of ZINT_BARCODE_DOTCODE
        Self.SetupSymbol('dot_size', 1)               !  
                                                      ! 
        Self.SetupSymbol('scale',    Choose(Self.Setting.sScale > 0,Self.Setting.sScale,10))
     end

   !  Message('sBorderWidth = ' & Self.Setting.sBorderWidth)
  end

!  ! Output_options
!
!ZINT_BARCODE_BIND_TOP        Equate(1)  ! Note: value was once used by the legacy (never-used) BARCODE_NO_ASCII
!ZINT_BARCODE_BIND            Equate(2)
!ZINT_BARCODE_BOX             Equate(4)
!ZINT_BARCODE_STDOUT          Equate(8)
!ZINT_READER_INIT             Equate(16)
!ZINT_SMALL_TEXT              Equate(32)
!ZINT_BOLD_TEXT               Equate(64)
!ZINT_CMYK_COLOUR             Equate(128)
!ZINT_BARCODE_DOTTY_MODE      Equate(256)
!ZINT_GS1_GS_SEPARATOR        Equate(512)
!ZINT_OUT_BUFFER_INTERMEDIATE Equate(1024)
!ZINT_BARCODE_QUIET_ZONES     Equate(2048)
!ZINT_BARCODE_NO_QUIET_ZONES  Equate(4096)
!ZINT_COMPLIANT_HEIGHT        Equate(8192)

! ---   ZINT
ZintClass.GetVersion  Procedure
  Code
  Return ZBarcode_Version()

! ---   -

ZintClass.Debug   Procedure
thisSymbol  &TZintSymbol
thisT1      CString(129)
thisT2      CString(129)
  Code

  If Self.FlagArmed = True

     thisSymbol &= (Self.Handle)
     thisT1      = Clip(thisSymbol.text)
     thisT2      = Clip(thisSymbol.primary)

     Message('symbology = '             & thisSymbol.symbology          & '|' & |
             'height = '                & thisSymbol.height             & '|' & |
             'whitespace_width = '      & thisSymbol.whitespace_width   & '|' & |
             'whitespace_height = '     & thisSymbol.whitespace_height  & '|' & |
             'border_width = '          & thisSymbol.border_width       & '|' & |
             'output_options = '        & thisSymbol.output_options     & '|' & |
             'fgcolour = '              & thisSymbol.fgcolour           & '|' & |
             'fgcolor = '               & thisSymbol.fgcolor            & '|' & |
             'bgcolour = '              & thisSymbol.bgcolour           & '|' & |
             'bgcolor = '               & thisSymbol.bgcolor            & '|' & |
             'outfile = '               & thisSymbol.outfile            & '|' & |
             'scale = '                 & thisSymbol.scale              & '|' & |
             'option_1 = '              & thisSymbol.option_1           & '|' & |
             'option_2 = '              & thisSymbol.option_2           & '|' & |
             'option_3 = '              & thisSymbol.option_3           & '|' & |
             'show_hrt = '              & thisSymbol.show_hrt           & '|' & |
             'input_mode = '            & thisSymbol.input_mode         & '|' & |
             'eci = '                   & thisSymbol.eci                & '|' & |
             'dpmm = '                  & thisSymbol.dpmm               & '|' & |
             'dot_size = '              & thisSymbol.dot_size           & '|' & |
             'guard_descent = '         & thisSymbol.guard_descent      & '|' & |
             'warn_level = '            & thisSymbol.warn_level         & '|' & | 
             'debug = '                 & thisSymbol.debug              & '|' & |
             'text = '                  & thisT1                        & '|' & |
             'text_length = '           & thisSymbol.text_length        & '|' & |
             'rows = '                  & thisSymbol.rows               & '|' & |
             'width = '                 & thisSymbol.width              & '|' & |
             'primary = '               & thisT2                        & '|' & |
             'errtxt = '                & thisSymbol.errtxt             & '|' & |
             'bitmap_width = '          & thisSymbol.bitmap_width       & '|' & |
             'bitmap_height = '         & thisSymbol.bitmap_height      & '|' & |
             'alphamap = '              & thisSymbol.alphamap           & '|' & |
             'memfile = '               & thisSymbol.memfile            & '|' & |
             'memfile_size = '          & thisSymbol.memfile_size       & '|' & |
             'zint_seg = '              & thisSymbol.zint_seg           & '|' & |
             'raw_seg_count = '         & thisSymbol.raw_seg_count      & '|' & | 
             '')
  end

! ---  

ZintClass.ViewError   Procedure(String NamePoint)
  Code

  If Self.FlagArmed = True

     Message(' : ' & Clip(Self.ErrorCode)            & |
             '|: '    & Clip(Self.GetSymbol('errtxt'))  & |
             '|: '     & Clip(Self.GetSymbol('text'))    & |
             '|: '      & Clip(Self.FileName)               |
             ,'  ' & Clip(NamePoint),Icon:Exclamation,'&1. ')
  end

! ---   -
ZintClass.ValidID     Procedure(Long symbol_id)
  Code
  If ZBarcode_ValidID(symbol_id) <> 0 then Return True else Return False.

! ---    
ZintClass.CapSymbol   Procedure(Long symbol_id,ULong cap_flag) !,Byte
  Code
  If ZBarcode_Cap(symbol_id,cap_flag) then Return True else Return False.

! ---   -
ZintClass.ZClear  Procedure
  Code
  If Self.FlagArmed = True then ZBarcode_Clear(Self.Handle).

! ---   -

ZintClass.SetupSymbol  Procedure(String pName,String pValue)
thisSymbol  &TZintSymbol
thisColor   String(6)
  Code

  If Self.FlagArmed = True

     thisSymbol &= (Self.Handle)

     Case Clip(Lower(pName))
     Of 'symbology'
        thisSymbol.symbology         = Clip(pValue)
     Of 'height'
        thisSymbol.height            = Clip(pValue)
     Of 'guard_descent'
        thisSymbol.guard_descent     = Clip(pValue)
     Of 'whitespace_width'
        thisSymbol.whitespace_width  = Clip(pValue)
     Of 'whitespace_height'
        thisSymbol.whitespace_height = Clip(pValue)
     Of 'border_width'
        thisSymbol.border_width      = Clip(pValue)
     Of 'output_options'
        thisSymbol.output_options    = Clip(pValue)
     Of 'fgcolour'
        thisColor                    = Sub(LongToHex(pValue,True),3,6)
        thisSymbol.fgcolour          = Sub(thisColor,5,2) & Sub(thisColor,3,2) & Sub(thisColor,1,2)
     Of 'fgcolour2'
        thisSymbol.fgcolour          = Sub(LongToHex(pValue,True),3,6)
     Of 'bgcolour'
        thisColor                    = Sub(LongToHex(pValue,True),3,6)
        thisSymbol.bgcolour          = Sub(thisColor,5,2) & Sub(thisColor,3,2) & Sub(thisColor,1,2)
     Of 'bgcolour2'
        thisSymbol.bgcolour          = Sub(LongToHex(pValue,True),3,6)
     Of 'outfile'
        thisSymbol.outfile           = Clip(pValue)
     Of 'scale'
        thisSymbol.scale             = Clip(pValue)
     Of 'option_1'
        thisSymbol.option_1          = Clip(pValue)
     Of 'option_2'
        thisSymbol.option_2          = Clip(pValue)
     Of 'option_3'
        thisSymbol.option_3          = Clip(pValue)
     Of 'show_hrt'
        thisSymbol.show_hrt          = Clip(pValue)
     Of 'input_mode'
        thisSymbol.input_mode        = Clip(pValue)
     Of 'eci'
        thisSymbol.eci               = Clip(pValue)
     Of 'dot_size'
        thisSymbol.dot_size          = Clip(pValue)
     Of 'debug'
        thisSymbol.debug             = Clip(pValue)
     else
        Message(' : ' & Clip(pName),'ZintClass.SetupSymbol',Icon:Exclamation,'&1. ')
     end
  end

! ---   -

ZintClass.GetSymbol  Procedure(String pName)
thisSymbol  &TZintSymbol
xRetValue   CString(256)
  Code

  If Self.FlagArmed = True

     thisSymbol &= (Self.Handle)

     Case Clip(Lower(pName))
     Of 'symbology'
        xRetValue = thisSymbol.symbology
     Of 'height'
        xRetValue = thisSymbol.height
     Of 'guard_descent'
        xRetValue = thisSymbol.guard_descent
     Of 'whitespace_width'
        xRetValue = thisSymbol.whitespace_width
     Of 'whitespace_height'
        xRetValue = thisSymbol.whitespace_height
     Of 'border_width'
        xRetValue = thisSymbol.border_width
     Of 'output_options'
        xRetValue = thisSymbol.output_options
     Of 'fgcolour'
        xRetValue = thisSymbol.fgcolour
     Of 'bgcolour'
        xRetValue = thisSymbol.bgcolour
     Of 'outfile'
        xRetValue = thisSymbol.outfile
     Of 'scale'
        xRetValue = thisSymbol.scale
     Of 'option_1'
        xRetValue = thisSymbol.option_1
     Of 'option_2'
        xRetValue = thisSymbol.option_2
     Of 'option_3'
        xRetValue = thisSymbol.option_3
     Of 'show_hrt'
        xRetValue = thisSymbol.show_hrt
     Of 'input_mode'
        xRetValue = thisSymbol.input_mode
     Of 'eci'
        xRetValue = thisSymbol.eci
     Of 'text'
        xRetValue = thisSymbol.text
     Of 'rows'
        xRetValue = thisSymbol.rows
     Of 'width'
        xRetValue = thisSymbol.width
     Of 'primary'
        xRetValue = thisSymbol.primary
     Of 'errtxt'
        xRetValue = thisSymbol.errtxt
     Of 'bitmap_width'
        xRetValue = thisSymbol.bitmap_width
     Of 'bitmap_height'
        xRetValue = thisSymbol.bitmap_height
     Of 'dot_size'
        xRetValue = thisSymbol.dot_size
     Of 'debug'
        xRetValue = thisSymbol.debug
     else
        Message(' : ' & Clip(pName),'ZintClass.GetSymbol',Icon:Exclamation,'&1. ')
     end
  end

  Return Clip(xRetValue)

! ---  -

ZintClass.ZEncode     Procedure(String source, Long in_length)
  Code

  Self.ErrorCode = -1

  If Self.FlagArmed = True
     Self.ErrorCode = ZBarcode_Encode(Self.Handle,source,in_length)
     If Self.ErrorCode <> 0 then Self.ViewError('ZEncode').
  end

  Return Self.ErrorCode

! ---  -

ZintClass.ZPrint      Procedure(Long rotate_angle)
  Code

  Self.ErrorCode = -1

  If Self.FlagArmed = True
     Self.ErrorCode = ZBarcode_Print(Self.Handle,rotate_angle)
     If Self.ErrorCode <> 0 then Self.ViewError('ZPrint').
  end

  Return Self.ErrorCode

! ---    -

ZintClass.EncodePrint Procedure(String source,Long in_length, Long rotate_angle)
Loc:SavePath  CString(File:MaxFilePath)
Loc:TempPath  CString(File:MaxFilePath)
  Code

  Self.ErrorCode = -1
  Clear(Self.FileName)

  If Self.FlagArmed = True

     !     -
     Clear(Self.xQIList)
     Self.xQIList.iFile = Clip(ZINT:GetGUID() & '.' & Self.FileExt)
     
     ! --- 18.03.2025 .         
      
     !Self.FileName = ZINT:GetRAMPath() & Self.xQIList.iFile
     !If Exists(Self.FileName) then ZINT:DeleteFileAPI(Self.FileName).
            
     !Self.SetupSymbol('outfile',Self.FileName)

     !!  -  
     !Self.ErrorCode = ZBarcode_Encode_and_Print(Self.Handle,source,in_length,rotate_angle)
     
     ! ---
     
     Loc:SavePath  = LongPath()
     Loc:TempPath  = ZINT:GetRAMPath()
     Self.FileName = Loc:TempPath & Self.xQIList.iFile
     
     SetPath(Loc:TempPath)
     If Exists(Self.xQIList.iFile) then ZINT:DeleteFileAPI(Self.xQIList.iFile).
            
     Self.SetupSymbol('outfile',Self.xQIList.iFile)

     !  -  
     Self.ErrorCode = ZBarcode_Encode_and_Print(Self.Handle,source,in_length,rotate_angle)    
          
     SetPath(Loc:SavePath)
     
     ! ----------------------------------------------------------

     !   -    -    
     If Self.ErrorCode <> 0
        Self.ViewError('EncodePrint')
        Clear(Self.FileName)

     elsIf Not Exists(Self.FileName)
        Clear(Self.FileName)
        Self.ErrorCode = -2

     elsIf Self.NoDelFile = False
        Add(Self.xQIList)
     end
  end

  Return Self.ErrorCode

! ---    -  

ZintClass.EncodeBuffer Procedure(String source,Long in_length, Long rotate_angle)
  Code

  Self.ErrorCode = -1

  If Self.FlagArmed = True

     !Self.ErrorCode = ZBarcode_Encode(Self.Handle, source,in_length)
     !If Self.ErrorCode <> 0 then Self.ViewError('Encode').

     !Self.ErrorCode = ZBarcode_Buffer(Self.Handle,rotate_angle)
     !If Self.ErrorCode <> 0 then Self.ViewError('Buffer').

     Self.ErrorCode = ZBarcode_Encode_and_Buffer(Self.Handle,source,in_length,rotate_angle)
     If Self.ErrorCode <> 0 then Self.ViewError('EncodeBuffer').
  end

  Return Self.ErrorCode

  ! ---   -   Image

ZintClass.CalcHeightBar  Procedure(Long xSymbol,Long xWidth,Long xHeight,Long xRotate_Angle) !,Long
xHeightBar    SReal(0)
xImageSize    Long
xBitmapHeight Long
  Code

  Case xSymbol
  Of ZINT_BARCODE_EANX OrOf ZINT_BARCODE_EAN14 OrOf ZINT_BARCODE_CODE128

     ! --- Easy version

     xImageSize = 230

     If InList(xRotate_Angle,90,270) = 0  !   Bitmap  ,   Image
        xBitmapHeight = Int((xImageSize * Abs(xHeight)) / Abs(xWidth))
     else
        xBitmapHeight = Int((xImageSize * Abs(xWidth))  / Abs(xHeight))
     end

     !xHeightBar = Int((xBitmapHeight - 18) / 2)
     xHeightBar = (xBitmapHeight - 18) / 2  !   2.10 SReal

     ! --- Full version

!     border_width# = 1  !  
!     scale#        = 1  ! 
!     xImageSize = (230 + (border_width# * 4)) * scale#
!
!     If InList(xRotate_Angle,90,270) = 0  !   Bitmap  ,   Image
!        xBitmapHeight = Int((xImageSize * Abs(xHeight)) / Abs(xWidth))
!     else
!        xBitmapHeight = Int((xImageSize * Abs(xWidth))  / Abs(xHeight))
!     end
!
!     ! 4 =   2 * 2 , 18 =     -
!     xHeightBar = Int( ((xBitmapHeight / scale#) - (border_width# * 4) - 16) / 2 )

!  Of ...
!  Else
  end

  !Message('xHeightBar = ' & xHeightBar)

  Return xHeightBar

  ! ---  -  Image Report

ZintClass.PrintToReport  Procedure(Report xReport,Short xImage,String xText)
thisSymbol  &TZintSymbol
xCodText    &String
xBMP        &String
xRetValue   Long(-1)
xSTMP       String(10)
  Code

  xReport$xImage{Prop:Hide}      = True
  xReport$xImage{Prop:ImageBits} = xSTMP       !  :     :(
                                           
  If Not Self.FlagArmed then Self.Init(True).  !      (  ) -    !
  If Self.FlagArmed = True

     !    -    Image
     If (Self.IPar[3] = 0) and (Self.IPar[4] = 0)

        Self.IPar[1] = xReport$xImage{Prop:XPos}    !   Self.BitmapToImage()
        Self.IPar[2] = xReport$xImage{Prop:YPos}
        Self.IPar[3] = xReport$xImage{Prop:Width}
        Self.IPar[4] = xReport$xImage{Prop:Height}

        Case Self.Setting.sSymbol  !      Image +  
        Of ZINT_BARCODE_EANX OrOf ZINT_BARCODE_EAN14 OrOf ZINT_BARCODE_CODE128
           If Self.Setting.sHeight = 0
              Self.SetupSymbol('height',Self.CalcHeightBar(Self.Setting.sSymbol,Self.IPar[3],Self.IPar[4],Self.Setting.sAngle))
           end
        end
     end

     xCodText &= Self.CheckAndParam(xText)  !    -
     If Not (xCodText &= Null)              !  -,     

        If ZBarcode_Encode_and_Buffer(Self.Handle,xCodText,Size(xCodText),Self.Setting.sAngle) = 0

           thisSymbol &= (Self.Handle)
           xBMP       &= Self.BitmapToBuffer(thisSymbol.bitmap_width,thisSymbol.bitmap_height,thisSymbol.bitmap)

           If Not (xBMP &= Null)
              xReport$xImage{Prop:ImageBits} = xBMP
              ResizeImage(xImage,Self.IPar[1],Self.IPar[2],Self.IPar[3],Self.IPar[4],xReport)
              xReport$xImage{Prop:Hide}      = False

              Dispose(xBMP)
              xRetValue = 0  !   
           end
        else
           Self.ViewError('PrintToReport')
        end

        Dispose(xCodText)
     end
  end

  Return xRetValue

  ! ---  -  Image Report
  ! ---    PrintToReport,     REPORT (   Field Report)  C11.1

ZintClass.PrintNewReport  Procedure(Short xImage, String xText, <Report xReport>)
thisSymbol  &TZintSymbol
xCodText    &String
xBMP        &String
xRetValue   Long(-1)
xSTMP       String(10)
  Code

  If Not Omitted(xReport) then SetTarget(xReport).

  Hide(xImage)                                 !   
  xImage{Prop:ImageBits} = xSTMP               !  :     :(
  
  If Not Self.FlagArmed then Self.Init(True).  !      (  ) -    !
  If Self.FlagArmed = True

     !    -    Image
     If (Self.IPar[3] = 0) and (Self.IPar[4] = 0)

        !   Self.BitmapToImage()
        GetPosition(xImage,Self.IPar[1],Self.IPar[2],Self.IPar[3],Self.IPar[4])

        Case Self.Setting.sSymbol  !      Image +  
        Of ZINT_BARCODE_EANX OrOf ZINT_BARCODE_EAN14 OrOf ZINT_BARCODE_CODE128
           If Self.Setting.sHeight = 0
              Self.SetupSymbol('height',Self.CalcHeightBar(Self.Setting.sSymbol,Self.IPar[3],Self.IPar[4],Self.Setting.sAngle))
           end
        end
     end

     xCodText &= Self.CheckAndParam(xText)  !    -
     If Not (xCodText &= Null)              !  -,     
     
        If ZBarcode_Encode_and_Buffer(Self.Handle,xCodText,Size(xCodText),Self.Setting.sAngle) = 0

           thisSymbol &= (Self.Handle)
           xBMP       &= Self.BitmapToBuffer(thisSymbol.bitmap_width,thisSymbol.bitmap_height,thisSymbol.bitmap)

           If Not (xBMP &= Null)
              xImage{Prop:ImageBits} = xBMP
              ResizeImage(xImage,Self.IPar[1],Self.IPar[2],Self.IPar[3],Self.IPar[4])
              UnHide(xImage) !  

              Dispose(xBMP)
              xRetValue = 0  !   
           end
        else
           Self.ViewError('PrintToReport')
        end

        Dispose(xCodText)
     end
  end

  !Self.Debug() !!!  -    MZ4x5.Report_Client

  If Not Omitted(xReport) then SetTarget.

  Return xRetValue

  ! ---   -  Image Report (     Self.IPar)

ZintClass.PrintOneSymbol  Procedure(Report xReport,Short xImage,String xText) !,Long,Proc
xSTMP       String(10)
xRetValue   Long(-1)
  Code

  xReport$xImage{Prop:Hide}      = True       !   
  xReport$xImage{Prop:ImageBits} = xSTMP      !  :     :(

  Case Self.Setting.sSymbol                   !      Image +   ( Image Report)
  Of ZINT_BARCODE_EANX OrOf ZINT_BARCODE_EAN14 OrOf ZINT_BARCODE_CODE128
     If Self.Setting.sHeight = 0
        Self.Setting.sHeight = Self.CalcHeightBar(Self.Setting.sSymbol,Self.IPar[3],Self.IPar[4],Self.Setting.sAngle)
     end
  !Of ...
  !Else
  end

  Self.WriteToBuffer(xText)
  If Not (Self.ImageBuffer &= Null)  !  BMP-  IMAGE

     xReport$xImage{Prop:ImageBits} = Self.ImageBuffer
     ResizeImage(xImage,Self.IPar[1],Self.IPar[2],Self.IPar[3],Self.IPar[4],xReport)
     xReport$xImage{Prop:Hide}      = False

     Dispose(Self.ImageBuffer)
     xRetValue = 0                   !   
  end

  Return xRetValue

  ! ---   -  Image Report (     Self.IPar)
  ! ---    PrintOneSymbol,     REPORT (   Field Report)  C11.1

ZintClass.PrintNewSymbol  Procedure(Short xImage, String xText, <Report xReport>) !,Long,Proc
xSTMP       String(10)
xRetValue   Long(-1)
  Code

  If Not Omitted(xReport) then SetTarget(xReport).

  Hide(xImage)                       !   
  xImage{Prop:ImageBits} = xSTMP     !  :     :(

  Case Self.Setting.sSymbol          !      Image +   ( Image Report)
  Of ZINT_BARCODE_EANX OrOf ZINT_BARCODE_EAN14 OrOf ZINT_BARCODE_CODE128
     If Self.Setting.sHeight = 0
        Self.Setting.sHeight = Self.CalcHeightBar(Self.Setting.sSymbol,Self.IPar[3],Self.IPar[4],Self.Setting.sAngle)
     end
  !Of ...
  !Else
  end

  Self.WriteToBuffer(xText)
  If Not (Self.ImageBuffer &= Null)  !  BMP-  IMAGE

     xImage{Prop:ImageBits} = Self.ImageBuffer
     ResizeImage(xImage,Self.IPar[1],Self.IPar[2],Self.IPar[3],Self.IPar[4])
     UnHide(xImage)                  !  

     Dispose(Self.ImageBuffer)
     xRetValue = 0                   !   
  end

  If Not Omitted(xReport) then SetTarget.

  Return xRetValue

  ! ---  -  Image Window  (     Self.IPar)

ZintClass.ExportToWindow  Procedure(Short xImage,String xText) !,Long,Proc
xSTMP       String(10)
xRetValue   Long(-1)
  Code

  Hide(xImage)                    !   
  xImage{Prop:ImageBits} = xSTMP  !  :     :(

  Case Self.Setting.sSymbol       !      Image +   ( Image Report)
  Of ZINT_BARCODE_EANX OrOf ZINT_BARCODE_EAN14 OrOf ZINT_BARCODE_CODE128
     If Self.Setting.sHeight = 0
        Self.Setting.sHeight = Self.CalcHeightBar(Self.Setting.sSymbol,Self.IPar[3],Self.IPar[4],Self.Setting.sAngle)
     end
  !Of ...
  !Else
  end

  Self.WriteToBuffer(xText)
  If Not (Self.ImageBuffer &= Null)  !  BMP-  IMAGE

     xImage{Prop:ImageBits} = Self.ImageBuffer
     ResizeImage(xImage,Self.IPar[1],Self.IPar[2],Self.IPar[3],Self.IPar[4])
     UnHide(xImage)                  !  

     Dispose(Self.ImageBuffer)
     xRetValue = 0                   !   
  end

  Return xRetValue

  ! ---    - 

ZintClass.WriteToFile  Procedure(String xText)
xCodText    &String
xRetValue   Long(-1)
  Code

  If Self.Init()                            !     

     xCodText &= Self.CheckAndParam(xText)  !    -
     If Not (xCodText &= Null)              !  -,   
        xRetValue = Self.EncodePrint(xCodText,Size(xCodText),Self.Setting.sAngle)
        Dispose(xCodText)
     end

    !Self.Kill()  ! :        (QR + EAN = BAD).   . :(
  end

  Return xRetValue

! ---      -

ZintClass.CheckAndParam  Procedure(*String xText)
zCodeError  Byte(False)
zCodText    &String
  Code

  !       -    
  If Self.Setting.sLength = 0 then Self.Setting.sLength = Len(Clip(xText)).

  !     -
  Case Self.Setting.sSymbol
  Of ZINT_BARCODE_EANX OrOf ZINT_BARCODE_EAN14
     If ZINT:CheckEan13(Sub(xText,1,Self.Setting.sLength),Self.CodName,Self.ErrorEan13) = False then zCodeError = True.
  !Of ...
  !Else
  end

  !         -    -
  If (zCodeError = False) and (Self.Setting.sLength > 0)

     Self.ZClear()  !  
     
     !  EAN13  BARCODE_CODE128
     If Self.Setting.sSymbol = ZINT_BARCODE_EANX and Len(Clip(Left(xText))) = 14
        Self.Setting.sSymbol = ZINT_BARCODE_CODE128        
        Self.Setting.sWSpaceWidth = 8
        
        Self.SetupSymbol('symbology',       Self.Setting.sSymbol)
        Self.SetupSymbol('whitespace_width',Self.Setting.sWSpaceWidth)   !   
     end

     Case Self.Setting.sSymbol
     Of ZINT_BARCODE_EANX OrOf ZINT_BARCODE_EAN14

        zCodText &= New(String(13))       !  EAN13 / EAN14   
        If Not (zCodText &= Null)

           If Int(Sub(Right(Clip(Left(Sub(xText,1,Self.Setting.sLength))),14),1,1)) = 0
              zCodText = Format(Sub(xText,1,Self.Setting.sLength),@n013)
           else
              Self.Setting.sSymbol = ZINT_BARCODE_EAN14
              zCodText = Sub(Format(Sub(xText,1,Self.Setting.sLength),@n014),1,13)
           end
        end
        
        !  -    BARCODE_CODE128
        Self.SetupSymbol('symbology',       Self.Setting.sSymbol)
        Self.SetupSymbol('whitespace_width',Self.Setting.sWSpaceWidth)
        
     Of ZINT_BARCODE_CODE128      OrOf |  ! -    Latin-1
        ZINT_BARCODE_AZTEC        OrOf |
        ZINT_BARCODE_PDF417       OrOf |
        ZINT_BARCODE_MICROPDF417  OrOf |
        ZINT_BARCODE_HANXIN
        
        zCodText &= New(String(Self.Setting.sLength))
        If Not (zCodText &= Null) then zCodText = Sub(xText,1,Self.Setting.sLength).

     Of ZINT_BARCODE_QRCODE       OrOf |  ! -    UTF-8
        ZINT_BARCODE_MICROQR      OrOf |
        ZINT_BARCODE_DATAMATRIX   OrOf |  ! <---   ECC200 ...
        ZINT_BARCODE_DOTCODE      OrOf |
        ZINT_BARCODE_ULTRA        OrOf |
        ZINT_BARCODE_RMQR
                                          !      UTF-8  
        zCodText &= Self.ConvertTextToUtf8(Sub(xText,1,Self.Setting.sLength))
     else
        Message(' -  : ' & Clip(Self.Setting.sSymbol) & ' !','  ',Icon:Exclamation,'&1. ')
     end
  end

  Return zCodText

! ---  -  
ZintClass.WriteToBuffer  Procedure(String xText)
thisSymbol  &TZintSymbol
xCodText    &String

  Code

  If Not (Self.ImageBuffer &= Null) then Dispose(Self.ImageBuffer).

  Self.BitmapWidth  = 0                     !  Bitmap    XLSX
  Self.BitmapHeight = 0

  If Self.Init(True)                        !      -    !

     xCodText &= Self.CheckAndParam(xText)  !    -
     If Not (xCodText &= Null)              !  -,     

        If ZBarcode_Encode_and_Buffer(Self.Handle,xCodText,Size(xCodText),Self.Setting.sAngle) = 0

           thisSymbol &= (Self.Handle)
           Self.ImageBuffer &= Self.BitmapToBuffer(thisSymbol.bitmap_width,thisSymbol.bitmap_height,thisSymbol.bitmap)

           If Not (Self.ImageBuffer &= Null)
              Self.BitmapWidth  = thisSymbol.bitmap_width   !  Bitmap    XLSX
              Self.BitmapHeight = thisSymbol.bitmap_height
           end
        else
           Self.ViewError('WriteToBuffer')
        end

        Dispose(xCodText)
     end

     !Self.Kill()  ! :        (QR + EAN = BAD).   . :(
  end

! ---  Bitmap -   ()

ZintClass.BitmapToBuffer  Procedure(Long bWidth_,Long bHeight_,ULong xBitmap_)

xBMP       String(Size(ZINT_BITMAPFILEHEADER) + Size(ZINT_BITMAPINFOHEADER) + (Band((bWidth_ * 3 + 3),0FFFFFFFCH) * bHeight_))

xHeader    Group,Over(xBMP)  !  BMP
FileHeader   Group(ZINT_BITMAPFILEHEADER).
InfoHeader   Group(ZINT_BITMAPINFOHEADER).
           end

xByteLine  Long,Auto
xRow       Long,Auto
xBuffer    &String

  Code

  xByteLine = Band((bWidth_ * 3 + 3),0FFFFFFFCH)  !    

  If (xByteLine > 0) and (bHeight_ > 0)  !   

     xBMP = All(Chr(0),Size(xBMP))       ! , ..    xBMP -  Byte[]

     !   BMP

     xHeader.FileHeader.bfType          = 4D42h
     xHeader.FileHeader.bfSize          = Size(xBMP)
     xHeader.FileHeader.bfReserved1     = 0
     xHeader.FileHeader.bfReserved2     = 0
     xHeader.FileHeader.bfOffBits       = Size(xHeader)

     xHeader.InfoHeader.biSize          = Size(ZINT_BITMAPINFOHEADER)
     xHeader.InfoHeader.biWidth         = bWidth_
     xHeader.InfoHeader.biHeight        = bHeight_
     xHeader.InfoHeader.biPlanes        = 1
     xHeader.InfoHeader.biBitCount      = 24
     xHeader.InfoHeader.biCompression   = 0
     xHeader.InfoHeader.biSizeImage     = 0
     xHeader.InfoHeader.biXPelsPerMeter = 0
     xHeader.InfoHeader.biYPelsPerMeter = 0
     xHeader.InfoHeader.biClrUsed       = 0  !  biBitCount
     xHeader.InfoHeader.biClrImportant  = 0

     !  Bitmap  BMP c      
     
     Loop xRow = 0 to (bHeight_ - 1)

       ZINT:memcpy(Address(xBMP) + xHeader.FileHeader.bfOffBits + (((bHeight_ - 1) - xRow) * xByteLine), |
                   xBitmap_ + (xRow * bWidth_ * 3), |
                   bWidth_ * 3)
     end

     xBuffer &= New(String(Size(xBMP)))
     If Not (xBuffer &= Null) then xBuffer = xBMP.
  end

  Return xBuffer

!! ---  Bitmap -  Image
!
!ZintClass.BitmapToImage Procedure(Report xReport,Short xImage,Long bWidth_,Long bHeight_,ULong xBitmap_)
!xBMP       &String
!xRetValue  Long(-1)
!  Code
!
!  xBMP &= Self.BitmapToBuffer(bWidth_,bHeight_,xBitmap_)  !  Bitmap  BMP-
!  If Not (xBMP &= Null)
!
!     xReport$xImage{Prop:ImageBits} = xBMP
!     ResizeImage(xImage,Self.IPar[1],Self.IPar[2],Self.IPar[3],Self.IPar[4],xReport)
!     xReport$xImage{Prop:Hide}      = False
!
!     Dispose(xBMP)
!     xRetValue = 0  !   
!  end
!
!  Return xRetValue

!ZintClass.BitmapToImage Procedure(<Report xReport>,Short xImage,Long bWidth_,Long bHeight_,ULong xBitmap_)
!
!xBMP       String(Size(ZINT_BITMAPFILEHEADER) + Size(ZINT_BITMAPINFOHEADER) + (Band((bWidth_ * 3 + 3),0FFFFFFFCH) * bHeight_))
!
!xHeader    Group,Over(xBMP)  !  BMP
!FileHeader   Group(ZINT_BITMAPFILEHEADER).
!InfoHeader   Group(ZINT_BITMAPINFOHEADER).
!           end
!
!xByteLine  Long,Auto
!xRow       Long,Auto
!xRetValue  Long(-1)
!
!  Code
!
!  xByteLine = Band((bWidth_ * 3 + 3),0FFFFFFFCH)  !    
!
!  If (xByteLine > 0) and (bHeight_ > 0)  !   
!
!     xBMP = All(Chr(0),Size(xBMP))       ! , ..    xBMP -  Byte[]
!
!     !   BMP
!
!     xHeader.FileHeader.bfType          = 4D42h
!     xHeader.FileHeader.bfSize          = Size(xBMP)
!     xHeader.FileHeader.bfReserved1     = 0
!     xHeader.FileHeader.bfReserved2     = 0
!     xHeader.FileHeader.bfOffBits       = Size(xHeader)
!
!     xHeader.InfoHeader.biSize          = Size(ZINT_BITMAPINFOHEADER)
!     xHeader.InfoHeader.biWidth         = bWidth_
!     xHeader.InfoHeader.biHeight        = bHeight_
!     xHeader.InfoHeader.biPlanes        = 1
!     xHeader.InfoHeader.biBitCount      = 24
!     xHeader.InfoHeader.biCompression   = 0
!     xHeader.InfoHeader.biSizeImage     = 0
!     xHeader.InfoHeader.biXPelsPerMeter = 0
!     xHeader.InfoHeader.biYPelsPerMeter = 0
!     xHeader.InfoHeader.biClrUsed       = 0  !  biBitCount
!     xHeader.InfoHeader.biClrImportant  = 0
!
!     !  Bitmap  BMP c      
!     
!     Loop xRow = 0 to (bHeight_ - 1)
!
!       ZINT:memcpy(Address(xBMP) + xHeader.FileHeader.bfOffBits + (((bHeight_ - 1) - xRow) * xByteLine), |
!                   xBitmap_ + (xRow * bWidth_ * 3), |
!                   bWidth_ * 3)
!     end
!
!     !    BMP  Image
!
!     If Omitted(xReport) = False       ! REPORT
!        xReport$xImage{Prop:ImageBits} = xBMP
!        ResizeImage(xImage,Self.IPar[1],Self.IPar[2],Self.IPar[3],Self.IPar[4],xReport)
!        xReport$xImage{Prop:Hide}      = False
!     else                              ! WINDOW
!        xImage{Prop:ImageBits} = xBMP
!        !ResizeImage(xImage,Self.IPar[1],Self.IPar[2],Self.IPar[3],Self.IPar[4])
!        !xImage{Prop:Hide}      = False
!     end
!
!     xRetValue = 0  !  
!  end
!
!  Return xRetValue

  ! ---   -   Self.Setting

ZintClass.Setting  Procedure(Long xSymbol)
  Code

  Clear(Self.Setting)

  Self.Setting.sSymbol       = xSymbol      ! -

  Self.Setting.sLength       = 0            !    0 = Len(Clip(Text))
  Self.Setting.sAngle        = 0            !  
  Self.Setting.sScale        = 0            !  

  Self.Setting.sColor        = Color:Black  !  
  Self.Setting.sCBack        = Color:White  !  

  Self.Setting.sHeight       = 0            !  
  Self.Setting.sBorderWidth  = 0            !  
  Self.Setting.sWSpaceWidth  = 0            !   
  Self.Setting.sWSpaceHeight = 0            !   
  Self.Setting.sQuietZone    = False        !  " "

  Self.Setting.sHideText     = False        !   
  Self.Setting.sBoldText     = False        !  
  Self.Setting.sSmallText    = False        !    
  Self.Setting.sGuardDescent = 5            !    (   -  'guard_descent' = 5/0,       )

! ---    ANSI  UTF-8

ZintClass.ConvertTextToUtf8  Procedure(String pStr)
UnicodeText   String(Size(pStr)*2+2)
bytesWritten  Long, Auto
xLen          Long, Auto
xCodText      &String
  Code

  bytesWritten = ZINT:MultiByteToWideChar(ZINT:GetACP(),0,Address(pStr),Len(pStr),Address(UnicodeText),Size(UnicodeText))

  xLen         = ZINT:WideCharToMultiByte(65001,0,Address(UnicodeText),bytesWritten,0,0,0,0)  !    UTF-8
  xCodText    &= New(String(Choose(xLen > 0,xLen,1)))

  If Not (xCodText &= Null)
     If ZINT:WideCharToMultiByte(65001,0,Address(UnicodeText),bytesWritten,Address(xCodText),Size(xCodText),0,0) <= 0 then Dispose(xCodText).
  end

  Return xCodText

! ---     

ZINT:GetRAMPath  Procedure
Loc:RPath  CString(File:MaxFilePath)

  Code

  Loc:RPath = Clip(Left(Command('RAM')))

  If Loc:RPath <> ''  !   
     Loc:RPath = LongPath(Loc:RPath)
     If Loc:RPath[Len(Loc:RPath)] <> '\' then Loc:RPath = Clip(Loc:RPath) & '\'.
     If Exists(Loc:RPath) then Return Loc:RPath.
  end

  Return LongPath(System{Prop:TempPath})

! ---  GUID

ZINT:GetGUID     Procedure
pGuid            String(16)
buf              String(128)
buf2             String(64)
cbSize           Long
Loc:RetValue     String(36)

  Code

  If Not ZINT:CoCreateGuid(pGUID)
     If ZINT:StringFromGuid2(pGuid, buf, SIZE(buf)/2)
        cbSize = ZINT:WideCharToMultiByte(, , Address(buf), -1, Address(buf2), SIZE(buf2), 0, 0)
        If cbSize > 0 then Loc:RetValue = buf2[2 : 37].
     end
  end

  Return Loc:RetValue

! ---      EAN13/14

ZINT:CheckEan13  Procedure(BarCode_,CodName_,MessEr_)
Loc:TC           String(14)
Loc:Count        Long
Loc:RetValue     Byte(False)  ! ,  - 
  Code

  Loc:TC = Right(Clip(Left(BarCode_)),14)

  If Clip(BarCode_) = ''
     If MessEr_ > 0  !     -
        Message('-  !','   !',Icon:Exclamation,'&1. ')
        Display
     end
  else
     Loop Loc:Count = 1 to 14
       If InList(Loc:TC[Loc:Count],'1','2','3','4','5','6','7','8','9','0')
          Break
       else
          Loc:TC[Loc:Count] = '0'
       end
     end

     Loc:Count  = (Int(Loc:TC[13]) + Int(Loc:TC[11]) + Int(Loc:TC[9]) + |
                   Int(Loc:TC[7])  + Int(Loc:TC[5])  + Int(Loc:TC[3]) + |
                   Int(Loc:TC[1])) * 3

     Loc:Count += Int(Loc:TC[12]) + Int(Loc:TC[10]) + Int(Loc:TC[8]) + |
                  Int(Loc:TC[6])  + Int(Loc:TC[4])  + Int(Loc:TC[2])

     Loc:Count  = (10 - (Loc:Count % 10)) % 10

     If Loc:TC[14] <> Loc:Count

        If MessEr_ = 2     !      -

           Message(Choose(Clip(Left(CodName_)) <> '',Clip(Left(CodName_)) & '||','') & |
                   '-: ' & Format(BarCode_,@P<#-######-######P)  & '||'      & |
                   '    - !|','    !',Icon:Exclamation,'&1. ')
           Display

        elsIf MessEr_ = 1  !        

           If Message(Choose(Clip(Left(CodName_)) <> '',Clip(Left(CodName_)) & '||','') & |
                      '-: ' & Format(BarCode_,@P<#-######-######P)  & '||'      & |
                      '    - !|','    !',Icon:Exclamation,'&1. |&2.  ',1) = 2

              MessEr_ = False
           end

        end
     else
        Loc:RetValue = True
     end
  end

  Return Loc:RetValue

! ---  HEX    

!ZINT::HexToLong  Procedure(String pHex)  !,Long
!RetVal   Long,Auto
!  Code
!
!  pHex   = Upper(pHex)
!  RetVal = InString(Sub(pHex,Len(Clip(pHex)),1),'123456789ABCDEF',1)
!  If Len(Clip(pHex)) > 1
!     RetVal += 16 * ZINT::HexToLong(Sub(pHex,1,Len(Clip(pHex)) - 1))
!  end
!
!  Return RetVal

ZINT::HexToLong  Procedure(String pHex)  !,Long
RetVal  Long(0)
lCoef   Long(1)
bCount  Byte,Auto

  Code
  Loop bCount = Len(pHex) to 1 by -1
    RetVal += InString(Upper(Sub(pHex,bCount,1)),'123456789ABCDEF',1) * lCoef
    lCoef  *= 16
  end

  Return RetVal