!    ZINT (C)
!   20.04.2025 .
! ------------------------------------------------
!    https://forum.clarionlife.net/
! https://sourceforge.net/projects/zint/
!   . \backend\zint.h

  Map
    Module('ZInt')          !  
      ZINT::HexToLong(String pHex),Long  !  HEX    
    end
  end

ZINT_VERSION_MAJOR           Equate(2)
ZINT_VERSION_MINOR           Equate(15)
ZINT_VERSION_RELEASE         Equate(0)
ZINT_VERSION_BUILD           Equate(9)

  ! Tbarcode 7 codes
ZINT_BARCODE_CODE11          Equate(1)
ZINT_BARCODE_C25STANDARD     Equate(2)
ZINT_BARCODE_C25INTER        Equate(3)
ZINT_BARCODE_C25IATA         Equate(4)
ZINT_BARCODE_C25LOGIC        Equate(6)
ZINT_BARCODE_C25IND          Equate(7)
ZINT_BARCODE_CODE39          Equate(8)
ZINT_BARCODE_EXCODE39        Equate(9)
ZINT_BARCODE_EANX            Equate(13)
ZINT_BARCODE_EANX_CHK        Equate(14)
ZINT_BARCODE_GS1_128         Equate(16)
ZINT_BARCODE_CODABAR         Equate(18)
ZINT_BARCODE_CODE128         Equate(20)
ZINT_BARCODE_DPLEIT          Equate(21)
ZINT_BARCODE_DPIDENT         Equate(22)
ZINT_BARCODE_CODE16K         Equate(23)
ZINT_BARCODE_CODE49          Equate(24)
ZINT_BARCODE_CODE93          Equate(25)
ZINT_BARCODE_FLAT            Equate(28)
ZINT_BARCODE_DBAR_OMN        Equate(29)
ZINT_BARCODE_DBAR_LTD        Equate(30)
ZINT_BARCODE_DBAR_EXP        Equate(31)
ZINT_BARCODE_TELEPEN         Equate(32)
ZINT_BARCODE_UPCA            Equate(34)
ZINT_BARCODE_UPCA_CHK        Equate(35)
ZINT_BARCODE_UPCE            Equate(37)
ZINT_BARCODE_UPCE_CHK        Equate(38)
ZINT_BARCODE_POSTNET         Equate(40)
ZINT_BARCODE_MSI_PLESSEY     Equate(47)
ZINT_BARCODE_FIM             Equate(49)
ZINT_BARCODE_LOGMARS         Equate(50)
ZINT_BARCODE_PHARMA          Equate(51)
ZINT_BARCODE_PZN             Equate(52)
ZINT_BARCODE_PHARMA_TWO      Equate(53)
ZINT_BARCODE_CEPNET          Equate(54)
ZINT_BARCODE_PDF417          Equate(55)
ZINT_BARCODE_PDF417COMP      Equate(56)
ZINT_BARCODE_MAXICODE        Equate(57)
ZINT_BARCODE_QRCODE          Equate(58)
ZINT_BARCODE_CODE128AB       Equate(60)
ZINT_BARCODE_CODE128B        Equate(60)  ! Legacy
ZINT_BARCODE_AUSPOST         Equate(63)
ZINT_BARCODE_AUSREPLY        Equate(66)
ZINT_BARCODE_AUSROUTE        Equate(67)
ZINT_BARCODE_AUSREDIRECT     Equate(68)
ZINT_BARCODE_ISBNX           Equate(69)
ZINT_BARCODE_RM4SCC          Equate(70)
ZINT_BARCODE_DATAMATRIX      Equate(71)
ZINT_BARCODE_EAN14           Equate(72)
ZINT_BARCODE_VIN             Equate(73)
ZINT_BARCODE_CODABLOCKF      Equate(74)
ZINT_BARCODE_NVE18           Equate(75)
ZINT_BARCODE_JAPANPOST       Equate(76)
ZINT_BARCODE_KOREAPOST       Equate(77)
ZINT_BARCODE_DBAR_STK        Equate(79)
ZINT_BARCODE_DBAR_OMNSTK     Equate(80)
ZINT_BARCODE_DBAR_EXPSTK     Equate(81)
ZINT_BARCODE_PLANET          Equate(82)
ZINT_BARCODE_MICROPDF417     Equate(84)
ZINT_BARCODE_USPS_IMAIL      Equate(85)
ZINT_BARCODE_PLESSEY         Equate(86)

  ! Tbarcode 8 codes
ZINT_BARCODE_TELEPEN_NUM     Equate(87)
ZINT_BARCODE_ITF14           Equate(89)
ZINT_BARCODE_KIX             Equate(90)
ZINT_BARCODE_AZTEC           Equate(92)
ZINT_BARCODE_DAFT            Equate(93)
ZINT_BARCODE_DPD             Equate(96)
ZINT_BARCODE_MICROQR         Equate(97)

  ! Tbarcode 9 codes
ZINT_BARCODE_HIBC_128        Equate(98)
ZINT_BARCODE_HIBC_39         Equate(99)
ZINT_BARCODE_HIBC_DM         Equate(102)
ZINT_BARCODE_HIBC_QR         Equate(104)
ZINT_BARCODE_HIBC_PDF        Equate(106)
ZINT_BARCODE_HIBC_MICPDF     Equate(108)
ZINT_BARCODE_HIBC_BLOCKF     Equate(110)
ZINT_BARCODE_HIBC_AZTEC      Equate(112)

  ! Tbarcode 10 codes
ZINT_BARCODE_DOTCODE         Equate(115)
ZINT_BARCODE_HANXIN          Equate(116)

  ! Tbarcode 11 codes
ZINT_BARCODE_MAILMARK_2D     Equate(119)
ZINT_BARCODE_UPU_S10         Equate(120)
ZINT_BARCODE_MAILMARK_4S     Equate(121)
ZINT_BARCODE_MAILMARK        Equate(121)  ! Legacy

  ! Zint specific
ZINT_BARCODE_AZRUNE          Equate(128)
ZINT_BARCODE_CODE32          Equate(129)
ZINT_BARCODE_EANX_CC         Equate(130)
ZINT_BARCODE_GS1_128_CC      Equate(131)
ZINT_BARCODE_DBAR_OMN_CC     Equate(132)
ZINT_BARCODE_DBAR_LTD_CC     Equate(133)
ZINT_BARCODE_DBAR_EXP_CC     Equate(134)
ZINT_BARCODE_UPCA_CC         Equate(135)
ZINT_BARCODE_UPCE_CC         Equate(136)
ZINT_BARCODE_DBAR_STK_CC     Equate(137)
ZINT_BARCODE_DBAR_OMNSTK_CC  Equate(138)
ZINT_BARCODE_DBAR_EXPSTK_CC  Equate(139)
ZINT_BARCODE_CHANNEL         Equate(140)
ZINT_BARCODE_CODEONE         Equate(141)
ZINT_BARCODE_GRIDMATRIX      Equate(142)
ZINT_BARCODE_UPNQR           Equate(143)
ZINT_BARCODE_ULTRA           Equate(144)
ZINT_BARCODE_RMQR            Equate(145)
ZINT_BARCODE_BC412           Equate(146)
ZINT_BARCODE_DXFILMEDGE      Equate(147)  ! DX Film Edge Barcode on 35mm and APS films
ZINT_BARCODE_EAN8_CC         Equate(148)  ! EAN-8 Composite
ZINT_BARCODE_EAN13_CC        Equate(149)  ! EAN-13 Composite
ZINT_BARCODE_LAST            Equate(149)  ! Max barcode number marker, not barcode

  ! Output options

ZINT_BARCODE_BIND_TOP        Equate(1)  ! Note: value was once used by the legacy (never-used) BARCODE_NO_ASCII
ZINT_BARCODE_BIND            Equate(2)
ZINT_BARCODE_BOX             Equate(4)
ZINT_BARCODE_STDOUT          Equate(8)
ZINT_READER_INIT             Equate(16)
ZINT_SMALL_TEXT              Equate(32)
ZINT_BOLD_TEXT               Equate(64)
ZINT_CMYK_COLOUR             Equate(128)
ZINT_BARCODE_DOTTY_MODE      Equate(256)
ZINT_GS1_GS_SEPARATOR        Equate(512)
ZINT_OUT_BUFFER_INTERMEDIATE Equate(1024)
ZINT_BARCODE_QUIET_ZONES     Equate(2048)
ZINT_BARCODE_NO_QUIET_ZONES  Equate(4096)
ZINT_COMPLIANT_HEIGHT        Equate(8192)
ZINT_EANUPC_GUARD_WHITESPACE Equate(16384)   ! Add quiet zone indicators ("<"/">") to HRT whitespace (EAN/UPC)
ZINT_EMBED_VECTOR_FONT       Equate(32768)   ! Embed font in vector output - currently only for SVG output
ZINT_BARCODE_MEMORY_FILE     Equate(10000H)  ! Write output to in-memory buffer `memfile` instead of to `outfile`
ZINT_BARCODE_RAW_TEXT        Equate(20000H)  ! Write data encoded to raw segment buffers `raw_segs`

  ! Input data types

ZINT_DATA_MODE               Equate(0)
ZINT_UNICODE_MODE            Equate(1)
ZINT_GS1_MODE                Equate(2)
ZINT_ESCAPE_MODE             Equate(8)
ZINT_GS1PARENS_MODE          Equate(16)  ! Process parentheses as GS1 AI delimiters (instead of square brackets)
ZINT_GS1NOCHECK_MODE         Equate(32)  ! Do not check validity of GS1 data (except that printable ASCII only)
ZINT_HEIGHTPERROW_MODE       Equate(64)  ! Interpret `height` as per-row rather than as overall height
ZINT_FAST_MODE               Equate(128) ! Use faster if less optimal encodation for symbologies that support it
                                         ! Note: affects DATAMATRIX, MICROPDF417, PDF417, QRCODE & UPNQR only
ZINT_EXTRA_ESCAPE_MODE       Equate(256) ! Process special symbology-specific escape sequences

  ! Data Matrix specific options

ZINT_DM_SQUARE               Equate(100)
ZINT_DM_DMRE                 Equate(101)
ZINT_DM_ISO_144              Equate(128)

  ! QR, Han Xin, Grid Matrix specific options (option_3)
ZINT_FULL_MULTIBYTE          Equate(200)

  ! Ultracode specific option (option_3)
ZINT_ULTRA_COMPRESSION       Equate(128)

  ! Warning and error conditions

ZINT_WARN_HRT_TRUNCATED      Equate(1)   ! Human Readable Text was truncated (max 199 bytes)
ZINT_WARN_INVALID_OPTION     Equate(2)   ! Invalid option given but overridden by Zint
ZINT_WARN_USES_ECI           Equate(3)   ! Automatic ECI inserted by Zint
ZINT_WARN_NONCOMPLIANT       Equate(4)   ! Symbol created not compliant with standards
ZINT_ERROR                   Equate(5)   ! Warn/error marker, not returned
ZINT_ERROR_TOO_LONG          Equate(5)   ! Input data wrong length
ZINT_ERROR_INVALID_DATA      Equate(6)   ! Input data incorrect
ZINT_ERROR_INVALID_CHECK     Equate(7)   ! Input check digit incorrect
ZINT_ERROR_INVALID_OPTION    Equate(8)   ! Incorrect option given
ZINT_ERROR_ENCODING_PROBLEM  Equate(9)   ! Internal error (should not happen)
ZINT_ERROR_FILE_ACCESS       Equate(10)  ! Error opening output file
ZINT_ERROR_MEMORY            Equate(11)  ! Memory allocation (malloc) failure
ZINT_ERROR_FILE_WRITE        Equate(12)  ! Error writing to output file
ZINT_ERROR_USES_ECI          Equate(13)  ! Error counterpart of warning if WARN_FAIL_ALL set (see below)
ZINT_ERROR_NONCOMPLIANT      Equate(14)  ! Error counterpart of warning if WARN_FAIL_ALL set
ZINT_ERROR_HRT_TRUNCATED     Equate(15)  ! Error counterpart of warning if WARN_FAIL_ALL set

  ! Warning warn (`symbol->warn_level`)

ZINT_WARN_DEFAULT            Equate(0)   ! Default behaviour
!ZINT_WARN_ZPL_COMPAT         Equate(1)  ! 
ZINT_WARN_FAIL_ALL           Equate(2)   ! Treat warning as error

  ! Capability flags (ZBarcode_Cap() `cap_flag`)

ZINT_CAP_HRT                 Equate(1)      ! Prints Human Readable Text?
ZINT_CAP_STACKABLE           Equate(2)      ! Is stackable?
ZINT_CAP_EANUPC              Equate(4)      ! Is extendable with add-on data? (Is UPC/EAN?)
ZINT_CAP_EXTENDABLE          Equate(4)      ! Legacy
ZINT_CAP_COMPOSITE           Equate(8)      ! Can have composite data?
ZINT_CAP_ECI                 Equate(16)     ! Supports Extended Channel Interpretations?
ZINT_CAP_GS1                 Equate(32)     ! Supports GS1 data?
ZINT_CAP_DOTTY               Equate(64)     ! Can be output as dots?
ZINT_CAP_QUIET_ZONES         Equate(128)    ! Has default quiet zones?
ZINT_CAP_FIXED_RATIO         Equate(256)    ! Has fixed width-to-height (aspect) ratio?
ZINT_CAP_READER_INIT         Equate(512)    ! Supports Reader Initialisation?
ZINT_CAP_FULL_MULTIBYTE      Equate(1024)   ! Supports full-multibyte option?
ZINT_CAP_MASK                Equate(2048)   ! Is mask selectable?
ZINT_CAP_STRUCTAPP           Equate(4096)   ! Supports Structured Append?
ZINT_CAP_COMPLIANT_HEIGHT    Equate(8192)   ! Has compliant height?
ZINT_CAP_BINDABLE            Equate(4000H)  ! Can set row separators?

  !

ZINT_MAX_DATA_LEN            Equate(17400) ! The largest amount of data that can be encoded is 4350 4-byte UTF-8 chars in Han Xin Code
ZINT_MAX_SEG_COUNT           Equate(256)   ! Maximum number of segments allowed for (`seg_count`)

  ! Debug flags

ZINT_DEBUG_PRINT             Equate(01H)
ZINT_DEBUG_TEST              Equate(02H)

  ! Raster file types

ZINT_OUT_BUFFER              Equate(0)
ZINT_OUT_SVG_FILE            Equate(10)
ZINT_OUT_EPS_FILE            Equate(20)
ZINT_OUT_EMF_FILE            Equate(30)
ZINT_OUT_PNG_FILE            Equate(100)
ZINT_OUT_BMP_FILE            Equate(120)
ZINT_OUT_GIF_FILE            Equate(140)
ZINT_OUT_PCX_FILE            Equate(160)
ZINT_OUT_JPG_FILE            Equate(180)
ZINT_OUT_TIF_FILE            Equate(200)

  ! ECI Code (Character Encoding Scheme)

ECI_ISO_8859_1               Equate(3)   ! Latin alphabet No. 1
ECI_ISO_8859_2               Equate(4)   ! Latin alphabet No. 2
ECI_ISO_8859_3               Equate(5)   ! Latin alphabet No. 3
ECI_ISO_8859_4               Equate(6)   ! Latin alphabet No. 4
ECI_ISO_8859_5               Equate(7)   ! Latin/Cyrillic alphabet
ECI_ISO_8859_6               Equate(8)   ! Latin/Arabic alphabet
ECI_ISO_8859_7               Equate(9)   ! Latin/Greek alphabet
ECI_ISO_8859_8               Equate(10)  ! Latin/Hebrew alphabet
ECI_ISO_8859_9               Equate(11)  ! Latin alphabet No. 5
ECI_ISO_8859_10              Equate(12)  ! Latin alphabet No. 6
ECI_ISO_8859_11              Equate(13)  ! Latin/Thai alphabet
ECI_ISO_8859_13              Equate(15)  ! Latin alphabet No. 7
ECI_ISO_8859_14              Equate(16)  ! Latin alphabet No. 8 (Celtic)
ECI_ISO_8859_15              Equate(17)  ! Latin alphabet No. 9
ECI_ISO_8859_16              Equate(18)  ! Latin alphabet No. 10
ECI_Shift_JIS                Equate(20)  ! JISX 0208 amd JISX 0201
ECI_Windows_1250             Equate(21)  ! Latin 2 (Central Europe)
ECI_Windows_1251             Equate(22)  ! Cyrillic
ECI_Windows_1252             Equate(23)  ! Latin 1
ECI_Windows_1256             Equate(24)  ! Arabic
ECI_UCS_2                    Equate(25)  ! Unicode (High order byte first)
ECI_Unicode                  Equate(26)  ! UTF-8
ECI_ISO_646:1991             Equate(27)  ! 7-bit character set
ECI_Big_5                    Equate(28)  ! (Taiwan) Chinese Character Set
ECI_GB                       Equate(29)  ! GB (PRC) Chinese Character Set
ECI_Korean                   Equate(30)  ! Korean Character Set (KSX1001:1998)

  !  

ZINT_BITMAPFILEHEADER  Group,Type
bfType                   UShort
bfSize                   ULong
bfReserved1              UShort
bfReserved2              UShort
bfOffbits                ULong    !  Bitmap
                       end

ZINT_BITMAPINFOHEADER  Group,Type
biSize                   Long
biWidth                  Long
biHeight                 Long
biPlanes                 Short
biBitCount               Short
biCompression            Long
biSizeImage              Long
biXPelsPerMeter          Long
biYPelsPerMeter          Long
biClrUsed                Long
biClrImportant           Long
                       end

zint_vector_rect    Group,Type
X           SReal
Y           SReal
Height      SReal
Width       SReal
Colour      Long
Next        ULong  ! &zint_vector_rect
                    end

zint_vector_hexagon Group,Type
X           SReal
Y           SReal
Diameter    SReal
Next        ULong  ! &zint_vector_hexagon
                    end

zint_vector_string  Group,Type
X           SReal
Y           SReal
FSize       SReal
Width       SReal
Length      Long
Rotation    Long   ! 0, 90, 180, 270 degrees
Halign      Long   ! Horizontal alignment: 0 for centre, 1 for left, 2 for right (end)
Text        ULong  ! unsigned char *text;
Next        ULong  ! &zint_vector_string
  end

zint_vector_circle  Group,Type
X           SReal
Y           SReal
Diameter    SReal
Width       SReal
Colour      Long
Next        ULong  ! &zint_vector_circle
                    end

zint_vector         Group,Type
Width       SReal
Height      SReal
Rectangles  ULong  ! &zint_vector_rect
Hexagons    ULong  ! &zint_vector_hexagon
Strings     ULong  ! &zint_vector_string
Circles     ULong  ! &zint_vector_circle
                    end

  ! --- Structured Append info - ignored unless `zint_structapp.count` is set to non-zero value */

zint_structapp      Group,Type
index       Long         ! int index;    /* Position in Structured Append sequence, 1-based. Must be <= `count` */
count       Long         ! int count;    /* Number of symbols in Structured Append sequence. Set >= 2 to add SA Info */
id          CString(32)  ! char id[32];  /* Optional ID to distinguish sequence, ASCII, NUL-terminated unless max 32 long */
                    end

  ! --- Segment for use with `ZBarcode_Encode_Segs()` below

zint_seg            Group,Type
source      ULong  ! unsigned char *source    Data to encode
length      Long   ! int length               Length of `source`. If 0, `source` must be NUL-terminated
eci         Long   ! int eci                  Extended Channel Interpretation
                    end

!zint_render_line    Group,Type
!X           SReal
!Y           SReal
!Length      SReal
!Width       SReal
!Next        ULong  ! &zint_render_line
!                    end
!
!zint_render_string  Group,Type
!X           SReal
!Y           SReal
!FSize       SReal
!Width       SReal
!Length      Long
!Text        ULong  ! unsigned char *text
!Next        ULong  ! &zint_render_string
!                    end
!
!zint_render_ring    Group,Type
!X           SReal
!Y           SReal
!Radius      SReal
!Line_Width  SReal
!Next        ULong  ! &zint_render_ring
!                    end
!
!zint_render_hexagon Group,Type
!X           SReal
!Y           SReal
!Height      SReal
!Next        ULong  ! &zint_render_hexagon
!                    end
!
!zint_render         Group,Type
!Width       SReal
!Height      SReal
!Lines       ULong  ! &zint_render_line
!Strings     ULong  ! &zint_render_string
!Rings       ULong  ! &zint_render_ring
!Hexagons    ULong  ! &zint_render_hexagon
!                    end

ZINT_xTypeQImage    Queue,Type
iFile                 CString(41)  ! GUID(36) & '.' & EXT(3)
                    end

TSetting            Group,Type
sSymbol               Long(ZINT_BARCODE_CODE128)
sLength               Long(0)            !   
sAngle                Long(0)            !  

sColor                Long(Color:Black)  !  
sCBack                Long(Color:White)  !  

sHeight               SReal(0)           !  
sGuardDescent         SReal(5)           !   ( EAN -   )
sScale                SReal              ! 

sBorderWidth          Long(0)            !  
sWSpaceWidth          Long(0)            !   
sWSpaceHeight         Long(0)            !   

sQuietZone            Byte(False)        !    (    )
sNoQuietZone          Byte(False)        !      (   )

sHideText             Byte(False)        !   
sBoldText             Byte(False)        !  
sSmallText            Byte(False)        !    

option_1              Long(0)
option_2              Long(0)
option_3              Long(0)
                    end
                    
!    /* Main symbol structure */
!    struct zint_symbol {
!        int symbology;      /* Symbol to use (see BARCODE_XXX below) */
!        float height;       /* Barcode height in X-dimensions (ignored for fixed-width barcodes) */
!        float scale;        /* Scale factor when printing barcode, i.e. adjusts X-dimension. Default 1 */
!        int whitespace_width; /* Width in X-dimensions of whitespace to left & right of barcode */
!        int whitespace_height; /* Height in X-dimensions of whitespace above & below the barcode */
!        int border_width;   /* Size of border in X-dimensions */
!        int output_options; /* Various output parameters (bind, box etc, see below) */
!        char fgcolour[16];  /* Foreground as hexadecimal RGB/RGBA or decimal "C,M,Y,K" string, NUL-terminated */
!        char bgcolour[16];  /* Background as hexadecimal RGB/RGBA or decimal "C,M,Y,K" string, NUL-terminated */
!        char *fgcolor;      /* Pointer to fgcolour (alternate spelling) */
!        char *bgcolor;      /* Pointer to bgcolour (alternate spelling) */
!        char outfile[256];  /* Name of file to output to, NUL-terminated. Default "out.png" ("out.gif" if no PNG) */
!        char primary[128];  /* Primary message data (MaxiCode, Composite), NUL-terminated */
!        int option_1;       /* Symbol-specific options (see "../docs/manual.txt") */
!        int option_2;       /* Symbol-specific options */
!        int option_3;       /* Symbol-specific options */
!        int show_hrt;       /* Show (1) or hide (0) Human Readable Text (HRT). Default 1 */
!        int input_mode;     /* Encoding of input data (see DATA_MODE etc below). Default DATA_MODE */
!        int eci;            /* Extended Channel Interpretation. Default 0 (none) */
!        float dpmm;         /* Resolution of output in dots per mm (BMP/EMF/PCX/PNG/TIF only). Default 0 (none) */
!        float dot_size;     /* Size of dots used in BARCODE_DOTTY_MODE. Default 0.8 */
!        float text_gap;     /* Gap between barcode and text (HRT) in X-dimensions. Default 1 */
!        float guard_descent; /* Height in X-dimensions that EAN/UPC guard bars descend. Default 5 */
!        struct zint_structapp structapp; /* Structured Append info. Default structapp.count 0 (none) */
!        int warn_level;     /* Affects error/warning value returned by Zint API (see WARN_XXX below) */
!        int debug;          /* Debugging flags */
!        unsigned char text[256]; /* Human Readable Text (HRT) (if any), UTF-8, NUL-terminated (output only) */
!        int text_length;    /* Length of text in bytes (output only) */
!        int rows;           /* Number of rows used by the symbol (output only) */
!        int width;          /* Width of the generated symbol (output only) */
!        unsigned char encoded_data[200][144]; /* Encoded data (output only). Allows for rows of 1152 modules */
!        float row_height[200]; /* Heights of rows (output only). Allows for 200 row DotCode */
!        char errtxt[160];   /* Error message if an error or warning occurs, NUL-terminated (output only) */
!        unsigned char *bitmap; /* Stored bitmap image (raster output only) */
!        int bitmap_width;   /* Width of bitmap image (raster output only) */
!        int bitmap_height;  /* Height of bitmap image (raster output only) */
!        unsigned char *alphamap; /* Array of alpha values used (raster output only) */
!        struct zint_vector *vector; /* Pointer to vector header (vector output only) */
!        unsigned char *memfile; /* Pointer to in-memory file buffer if BARCODE_MEMORY_FILE (output only) */
!        int memfile_size;   /* Length of in-memory file buffer (output only) */
!        struct zint_seg *raw_segs; /* Pointer to array of raw segs if BARCODE_RAW_TEXT (output only) */
!        int raw_seg_count;  /* Number of `raw_segs` (output only) */
!    };

TZintSymbol         Group,Type
symbology             Long
height                SReal
scale                 SReal
whitespace_width      Long
whitespace_height     Long
border_width          Long
output_options        Long
fgcolour              CString(16)
bgcolour              CString(16)
fgcolor               ULong  ! pointer to fgcolour
bgcolor               ULong  ! pointer to bgcolour
outfile               CString(256)
primary               CString(128)
option_1              Long
option_2              Long
option_3              Long
show_hrt              Long   !     
input_mode            Long
eci                   Long
dpmm                  SReal  ! Resolution of output in dots per mm (BMP/EMF/PCX/PNG/TIF only). Default 0 (none)
dot_size              SReal
text_gap              SReal
guard_descent         SReal
structapp             Group(zint_structapp).
warn_level            Long
debug                 Long
text                  CString(256)
text_length           Long
rows                  Long
width                 Long
encoded_data          Byte,Dim(200,144)
row_height            SReal,Dim(200)
errtxt                CString(160)
bitmap                ULong  ! &String
bitmap_width          Long
bitmap_height         Long
alphamap              ULong  ! &char ---
vector                ULong  ! &zint_vector
memfile               ULong  ! Pointer to in-memory file buffer if BARCODE_MEMORY_FILE (output only)
memfile_size          Long   ! Length of in-memory file buffer (output only)
zint_seg              ULong  ! Pointer to array of raw segs if BARCODE_RAW_TEXT (output only)
raw_seg_count         Long   ! Number of `raw_segs` (output only)
                    end

! --- ZINT BarCode Class

ZintClass           Class, Type, Module('zint.clw'), Link('zint.clw')

FlagArmed             Byte(False), Private
Handle                Long,        Private
ErrorCode             Long,        Private

FileName              CString(File:MaxFileName)                !    
FileExt               CString(4)                               !  ()   
IPar                  Short,Dim(4)                             !  IMAGE
ImageBuffer           &String                                  !    -

xQIList               &ZINT_xTypeQImage,Private                !    -
NoDelFile             Byte(False)                              !     

CodName               CString(201)                             !   (     EAN13)
ErrorEan13            Byte(1)                                  !       EAN13

Setting               Group(TSetting).                         !   -

BitmapWidth           Long(0)                                  !  Bitmap    XLSX
BitmapHeight          Long(0)

  ! ---  

Construct             Procedure
Destruct              Procedure

Init                  Procedure(Byte bAltSetColor = False),Byte,Proc,Private
Kill                  Procedure

GetVersion            Procedure(),Long                         !   ZINT ( =    )
Debug                 Procedure                                !   -
ViewError             Procedure(String NamePoint)              !  
ConvertTextToUtf8     Procedure(String pStr),*String,Private   !     UTF-8

ValidID               Procedure(Long symbol_id),Byte           !   -
                                                               !    
CapSymbol             Procedure(Long symbol_id,ULong cap_flag),Byte

SetupSymbol           Procedure(String pName,String pValue)    !   -
GetSymbol             Procedure(String pName),String           !   -

ZClear                Procedure,Private                        !   -
ZConfigure            Procedure(Byte bAltSetColor),Private     !     Self.Setting

                                                               !   -
ZEncode               Procedure(String source, Long in_length),Long,Proc,Private
                                                               !  -
ZPrint                Procedure(Long rotate_angle),Long,Proc,Private
                                                               !    -
EncodePrint           Procedure(String source,Long in_length, Long rotate_angle),Long,Proc,Private
                                                               !    -  
EncodeBuffer          Procedure(String source,Long in_length, Long rotate_angle),Long,Proc,Private

  ! ---  -

Setting               Procedure(Long xSymbol)                  !   -
                                                               !      -
CheckAndParam         Procedure(*String xText),*String,Private
                                                               !      Image
CalcHeightBar         Procedure(Long xSymbol,Long xWidth,Long xHeight,Long xRotate_Angle),SReal

WriteToFile           Procedure(String xText),Long,Proc        !  -  
WriteToBuffer         Procedure(String xText)                  !  -   &Self.ImageBuffer

                                                               !  -  Image Report
PrintToReport         Procedure(Report xReport,Short xImage,String xText),Long,Proc
                                                               !   -  Image Report   
PrintOneSymbol        Procedure(Report xReport,Short xImage,String xText),Long,Proc

                                                               !  -  Image Report ( REPORT)
PrintNewReport        Procedure(Short xImage,String xText,<Report xReport>),Long,Proc
                                                               !   -  Image Report    ( REPORT)
PrintNewSymbol        Procedure(Short xImage,String xText,<Report xReport>),Long,Proc

                                                               !  -  Image Window
ExportToWindow        Procedure(Short xImage,String xText),Long,Proc
                                                               !  Bitmap -   ()
BitmapToBuffer        Procedure(Long bWidth_,Long bHeight_,ULong xBitmap_),*String,Private
!                                                               !  Bitmap -  Image
!BitmapToImage         Procedure(Report xReport,Short xImage,Long bWidth_,Long bHeight_,ULong xBitmap_),Long,Private
                    end